<?php

// Enable error reporting;
error_reporting(E_ALL);
include 'db.php';

// Tie in with Cacti authentication
chdir("../");
#include_once("./include/auth.php");

/*
 * Edit variables here for directories and output files etc, nothing else should need editing;
 */

// Full path to rrdtool binary
$rrdtool="/usr/bin/rrdtool";

/*
 * End of variables
 */


# Return an XML list of data source ID, with router/switch interface name and description
if (isset($_GET['action']) && $_GET['action']=="get_hostid_graphs" && isset($_GET['hostid']) && isset($_GET['hosttype'])) {

 if($_GET['hosttype']=="cisco") {
   $sql = "SELECT `gl`.id, `hsc`.field_value
         FROM `graph_local` AS gl
         INNER JOIN `host_snmp_cache` hsc ON `gl`.host_id = `hsc`.host_id
         WHERE `gl`.host_id = ".$_GET['hostid']."
         AND `gl`.snmp_index = `hsc`.snmp_index
         AND `hsc`.field_name IN ('ifAlias', 'ifName') ORDER BY `gl`.id, `hsc`.field_name";
 } elseif ($_GET['hosttype']=="m0n0wall") {
   $sql = "SELECT `gl`.id, `hsc`.field_value
         FROM `graph_local` AS gl
         INNER JOIN `host_snmp_cache` hsc ON `gl`.host_id = `hsc`.host_id
         WHERE `gl`.host_id = ".$_GET['hostid']."
         AND `gl`.snmp_index = `hsc`.snmp_index
         AND `hsc`.field_name IN ('ifDescr', 'ifIP') ORDER BY `gl`.id, `hsc`.field_name";
 } else { 
  die();
 }

 $db = mysql_select_db("cacti");
 $result = mysql_query($sql);
 if(!$result) {
  die("Couldn't get list of graphs from host Id: ".mysql_error());
 }

 Header("Content-type: text/xml");
 $xml = "<graphs name=\"graphs\">";
 $xml = $xml . "<graph id=\"\"></graph>";
 if(mysql_num_rows($result)>0) {
  for($row=0;$row<mysql_num_rows($result);$row++) {
   mysql_data_seek($result, $row);
   $rows=mysql_fetch_assoc($result);
   $description = htmlspecialchars($rows['field_value'], ENT_QUOTES);
   // Not all graphs and both peices of information, so hack around user error...
   if($row+1<mysql_num_rows($result)) {
     $row++;
     mysql_data_seek($result, $row);
     $rows=mysql_fetch_assoc($result);
     $port = htmlspecialchars($rows['field_value'], ENT_QUOTES);
   } else { 
     $port = "";
     $row++;
   }
   $xml = $xml . "<graph id=\"".$rows['id']."\">".$port." ".$description."</graph>";
  }
 }
 $xml = $xml . "</graphs>";
 echo $xml;

}


if (isset($_GET['action']) && $_GET['action']=="get_graphid_source_name" && isset($_GET['hostid']) && isset($_GET['graphid'])) {

 $sql = "SELECT DISTINCT data_template_rrd.local_data_id, data_template_rrd.data_source_name
         FROM
         data_template_rrd
         LEFT JOIN graph_templates_item ON graph_templates_item.task_item_id = data_template_rrd.id
         LEFT JOIN graph_local ON graph_local.id = graph_templates_item.local_graph_id
         WHERE graph_local.id=".$_GET['graphid'];
 $db = mysql_select_db("cacti");
 $result = mysql_query($sql);
 if(!$result) {
  die("Couldn't get list of sources from graph ID: ".mysql_error());
 }

 Header("Content-type: text/xml");
 $xml = "<sources name=\"sources\">";
 $xml = $xml . "<source id=\"\"></source>";
 if(mysql_num_rows($result)>0) {
  while($row=mysql_fetch_assoc($result)) {
   $xml = $xml . "<source id=\"".$row['local_data_id']."\">".$row['data_source_name']."</source>";
  }
 }
 $xml = $xml . "</sources>";
 echo $xml;

}

if (isset($_GET['action']) && $_GET['action']=="get_graphid_dates" && isset($_GET['hostid']) && isset($_GET['sourceid'])) {

 // Grab the rrd file path for the posted data source
 $sql = "SELECT DISTINCT rrd_path from `poller_item` WHERE host_id = '".$_GET['hostid']."' AND local_data_id = '".
        $_GET['sourceid']."' LIMIT 0,1";
 $db = mysql_select_db("cacti");
 $result = mysql_query($sql);

 if(!$result || mysql_num_rows($result)!=1) {
  die("Couldn't find rrd path for data source in MySQL DB : ".mysql_error());
 }

 $rrd_path=mysql_fetch_array($result);

 /*
  * Example CMD:
  * /usr/bin/rrdtool dump /opt/cacti-0.8.8c/rra/xxxxxxxxx_traffic_in_2202.rrd | sed -n -e '/<database>/,/<\/database>/p;/<\/database>/q;' | sed -e '1d;$d' | less
  * Example Output:
  * <!-- 2015-08-25 11:10:00 BST / 1440497400 --> <row><v>7.8358739704e+06</v><v>2.2483650370e+07</v></row>
  */
 $rrd_start_cmd = "$rrdtool dump $rrd_path[0] | sed -n -e '/<database>/,/<\/database>/p;/<\/database>/q;' | sed -e '1d;\$d' | sed -n -e '1p;'"; //head -n 1";
 $rrd_end_cmd = "$rrdtool dump $rrd_path[0] | sed -n -e '/<database>/,/<\/database>/p;/<\/database>/q;' | sed -e '1d;\$d' | sed -n -e '\$p;'"; //tail -n 1";
 $rrd_start_output = shell_exec($rrd_start_cmd);
 $rrd_end_output = shell_exec($rrd_end_cmd);

 // Now grep the date/time from the CMD output
 $rrd_start = preg_split("/ /", $rrd_start_output);
 $rrd_end = preg_split("/ /", $rrd_end_output);

 Header("Content-type: text/xml");
 $xml = "<dates name=\"dates\">";
 $xml = $xml . "<date id=\"0\">" . $rrd_start[1] . " " . $rrd_start[2] . "</date>";
 $xml = $xml . "<date id=\"1\">" . $rrd_end[1] . " " . $rrd_end[2] . "</date>";
 $xml = $xml . "</dates>";
 echo $xml;

}


?>
